(* GNU-GPL
 * System Compression - Plugin de compression LZH pour le logiciel System C
 * Copyright (c) 2002 Ulrich Van Den Hekke (ulrich.vdh@free.fr)
 * 24 rue Jean Jaures
 * 59560 Comines
 *
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
 * les termes de la Licence Publique Gnrale GNU publie par la
 * Free Software Foundation (version 2 ou bien toute autre version ultrieure
 * choisie par vous).
 *
 * Ce programme est distribu car potentiellement utile, mais
 * SANS AUCUNE GARANTIE, ni explicite ni implicite, y compris les garanties de
 * commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 * Licence Publique Gnrale GNU pour plus de dtails.
 *
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
 * temps que ce programme ; si ce n'est pas le cas, crivez  la
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 *
 *)

(******************************************************************************)
(* Plugin de compression LZH pour le logiciel System C                        *)
(* Version : 1.0.0.0                                                          *)
(* Author : Ulrich Van Den Hekke                                              *)
(* Create day : 06/07/2002                                                    *)
(* -------------------------------------------------------------------------- *)
(* Serial : 7A4CC6-02091100-FC2362E8                                          *)
(* Object : Compresse le fichier au format LZH                                *)
(******************************************************************************)

library LZH;

uses
  Windows,
  SysUtils,
  Common in 'Common.pas',
  Lzhuf in 'LZHuf.pas';

{$E ALG}

{$R *.RES}

{$LIBPREFIX 'sys'}

resourcestring
  rsAboutCaption  = 'A propos de ...';
  rsAboutText     = 'Plugin de compression LZH, Version v%d.%.2d par Ulrich Van Den Hekke';

const
  cstInformations : TInformations
                  = (iName        : 'lzh'#0#0#0#0#0#0#0#0#0#0#0#0#0;
                     iDescription : 'Compresse au format LZH'#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0;
                     iSerial      : '7A4CC6-02091100-FC2362E8';
                     iVersion     : 0;
                    );

var Cont: boolean;
    get : TGetByte;
    put : TPutByte;

function Informations: TInformations; stdcall;
begin
  result := cstInformations;
end;

procedure About(hWnd: HWND); stdcall;
begin
  MessageBox(hWnd, PChar(Format(rsAboutText, [1, 0])), PChar(rsAboutCaption), MB_OK or MB_ICONINFORMATION);
end;

function PutOneByte(aByte : Byte; Flush : Boolean) : Boolean;
begin
  put(aByte, flush);
  result := true;
end;

function GetOneByte(var aByte : Byte) : Boolean;
begin
  cont   := get(aByte);
  result := cont;
end;

procedure Pack(var BytesWritten: Integer; const getProc: TGetByte; const putProc: TPutByte); stdcall;
begin
  get := getProc; put := putProc;
  LZHPack(BytesWritten, GetOneByte, PutOneByte);
end;

procedure Unpack(const TextSize: Integer; const getProc: TGetByte; const putProc: TPutByte); stdcall;
begin
  get := getProc; put := putProc;
  LZHUnpack(TextSize, GetOneByte, PutOneByte);
end;

exports
  Informations,
  About,
  Pack,
  Unpack;
                    
begin
end.
